/*
-- =====================================================================
-- CUSTOSERV - Custo de Servios do Manual e Custo da Apresentao
-- =====================================================================
*/
CREATE OR REPLACE PROCEDURE CUSTOSERV(
P_CDSEQCUSSE IN OUT CUSTOSEMA.CDSEQCUSSE%TYPE, -- Deve ser passado para o parmetro '0000000000'.
P_IDTIPMAN   IN VARCHAR DEFAULT 'M', -- 'M' - Manual Aprovado; 'A' - Manual da Apresentao.
P_CDSEQITEM  IN OUT NUMBER,
P_IDINSERES  IN VARCHAR DEFAULT 'N', -- 'S' - Insere Servio; 'N' - No Insere Servio.
P_IDINSEREP  IN VARCHAR DEFAULT 'N', -- 'S' - Insere Produto; 'N' - No Insere Produto; 'P' - Insere Somente os Produtos Principais.
P_IDINSERER  IN VARCHAR DEFAULT 'N', -- 'S' - Insere Receita; 'N' - No Insere Receita; 'P' - Insere Somente as Receitas Principais.
P_CDFILIAL   IN FILIAL.CDFILIAL%TYPE,
P_CDCIA      IN COMPANHIA.CDCIA%TYPE,
P_CDMANCIA   IN MANUALCIA.CDMANCIA%TYPE,
P_CDSERVICO  IN SERVMANUAL.CDSERVICO%TYPE DEFAULT NULL,
/*P_CDCLASSE   IN SERVMANUAL.CDCLASSE%TYPE DEFAULT NULL,
P_CDCICLO    IN SERVMANUAL.CDCICLO%TYPE DEFAULT NULL,*/
P_CDSUBGRU   IN VARCHAR DEFAULT NULL, -- Todos ou Lista
P_DTCUSTO    IN DATE,
P_CDOPERADOR IN OPERADOR.CDOPERADOR%TYPE,

VRCUSULCLIQSER OUT NUMBER,
VRCUSULCBRUSER OUT NUMBER,
VRCUSMEDLIQSER OUT NUMBER,
VRCUSMEDBRUSER OUT NUMBER
) AS
V_CDSEQCUSSE VARCHAR2(20);
V_CDMANCIA   MANUALCIA .CDMANCIA%TYPE;
V_CDSERVICO  SUBGRUSEMA.CDSERVICO%TYPE;
/*V_CDCLASSE   SUBGRUSEMA.CDCLASSE%TYPE;
V_CDCICLO    SUBGRUSEMA.CDCICLO%TYPE;*/
V_CDSUBGRU   SUBGRUSEMA.CDSUBGRU%TYPE;

V_CUSULCLIQSG NUMBER;
V_CUSULCBRUSG NUMBER;
V_CUSMEDLIQSG NUMBER;
V_CUSMEDBRUSG NUMBER;

V_CUSULCLIQSERT NUMBER;
V_CUSULCBRUSERT NUMBER;
V_CUSMEDLIQSERT NUMBER;
V_CUSMEDBRUSERT NUMBER;

/* Manual Aprovado */
/*CURSOR C_SUBMA IS
SELECT CDMANCIA,CDSERVICO,--CDCLASSE,CDCICLO,
       CDSUBGRU
FROM SUBGRUSEMA
WHERE (CDFILIAL  = P_CDFILIAL ) AND
      (CDCIA     = P_CDCIA    ) AND
      (CDMANCIA  = P_CDMANCIA ) AND
      (CDSERVICO = NVL(P_CDSERVICO,CDSERVICO)) AND
      --(CDCLASSE  = NVL(P_CDCLASSE ,CDCLASSE )) AND
      --(CDCICLO   = NVL(P_CDCICLO  ,CDCICLO  )) AND
      --(INSTR(NVL(P_CDSUBGRU,CDSERVICO||CDCLASSE||CDCICLO||CDSUBGRU),
      -- CDSERVICO||CDCLASSE||CDCICLO||CDSUBGRU)>0);
      (INSTR(NVL(P_CDSUBGRU,CDSERVICO||CDSUBGRU),CDSERVICO||CDSUBGRU)>0);*/
CURSOR C_SUBMA IS
SELECT EP.CDMANCIA,EP.CDPRODUTO AS CDSERVICO,CP.CDPRODINSUMO AS CDSUBGRU
FROM ESPEPROD EP, COMPPROD CP, PRODUTO PR
WHERE (EP.CDFILIAL     = P_CDFILIAL     ) AND
      (EP.CDCIA        = P_CDCIA        ) AND
      (EP.CDMANCIA     = P_CDMANCIA     ) AND
      (EP.CDPRODUTO    = NVL(P_CDSERVICO,EP.CDPRODUTO)) AND
      (EP.IDTPMANUAL   = 'M'            ) AND
      (CP.CDESPEPROD   = EP.CDESPEPROD  ) AND
      (CP.CDPRODUTO    = EP.CDPRODUTO   ) AND
      (INSTR(NVL(P_CDSUBGRU,CP.CDPRODUTO||CP.CDPRODINSUMO),CP.CDPRODUTO||CP.CDPRODINSUMO)>0) AND
      (PR.CDPRODUTO    = CP.CDPRODINSUMO) AND
      (PR.IDPRODCOMISS = '2'            );
/* Manual da Apresentao */
CURSOR C_SUBAP IS
SELECT CDMANAP,NULL,/*NULL,NULL,*/CDSUBGRU
FROM SUBGRUSEAP
WHERE (CDFILIAL  = P_CDFILIAL ) AND
      (CDCIA     = P_CDCIA    ) AND
      (CDMANAP   = NVL(P_CDMANCIA, CDMANAP)) AND
      (INSTR(NVL(P_CDSUBGRU,CDMANAP||CDSUBGRU),CDMANAP||CDSUBGRU)>0);

BEGIN
   V_CUSULCLIQSERT := 0;
   V_CUSULCBRUSERT := 0;
   V_CUSMEDLIQSERT := 0;
   V_CUSMEDBRUSERT := 0;

	IF (P_CDSEQCUSSE = '0000000000') AND
      ((P_IDINSERES  = 'S') OR
       (P_IDINSEREP <> 'N') OR
       (P_IDINSERER <> 'N')) THEN
		NOVO_CODIGO('CUSTOSCOC'||P_CDFILIAL,V_CDSEQCUSSE,1);
      P_CDSEQCUSSE := SUBSTR(V_CDSEQCUSSE,11,10);
   END IF;

   IF P_IDTIPMAN = 'M' THEN
      OPEN C_SUBMA;
   ELSIF P_IDTIPMAN = 'A' THEN
      OPEN C_SUBAP;
   END IF;
   LOOP
      IF P_IDTIPMAN = 'M' THEN
         FETCH C_SUBMA
         INTO V_CDMANCIA,V_CDSERVICO,/*V_CDCLASSE,V_CDCICLO,*/V_CDSUBGRU;
         EXIT WHEN C_SUBMA%NOTFOUND;
      	--VERIFICA_ESPEPROD(P_CDFILIAL,P_CDCIA,V_CDMANCIA,'M','P',V_CDSUBGRU); /* Verifica a especificao para sub-grupos do manual */
      ELSIF P_IDTIPMAN = 'A' THEN
         FETCH C_SUBAP
         INTO V_CDMANCIA,V_CDSERVICO,/*V_CDCLASSE,V_CDCICLO,*/V_CDSUBGRU;
         EXIT WHEN C_SUBAP%NOTFOUND;
      	--VERIFICA_ESPEPROD(P_CDFILIAL,P_CDCIA,V_CDMANCIA,'A','P',V_CDSUBGRU); /* Verifica a especificao para sub-grupos da apresentao */
      END IF;

      CUSTOSUBG(P_CDSEQCUSSE,P_IDTIPMAN,P_CDSEQITEM,P_IDINSEREP,
                P_IDINSERER,P_CDFILIAL,P_CDCIA,V_CDMANCIA,
                V_CDSERVICO,/*V_CDCLASSE,V_CDCICLO,*/
                V_CDSUBGRU,P_DTCUSTO,P_CDOPERADOR,
                V_CUSULCLIQSG,V_CUSULCBRUSG,
                V_CUSMEDLIQSG,V_CUSMEDBRUSG);

      V_CUSULCLIQSERT := V_CUSULCLIQSERT + V_CUSULCLIQSG;
      V_CUSULCBRUSERT := V_CUSULCBRUSERT + V_CUSULCBRUSG;
      V_CUSMEDLIQSERT := V_CUSMEDLIQSERT + V_CUSMEDLIQSG;
      V_CUSMEDBRUSERT := V_CUSMEDBRUSERT + V_CUSMEDBRUSG;
   END LOOP;

   IF P_IDINSERES = 'S' THEN
      INSERT INTO CUSTOSEMA
      (CDSEQCUSSE,CDFILIAL,CDCIA,CDMANCIA,
       CDSERVICO,/*CDCLASSE,CDCICLO,*/
       DTCUSTOMA,DTHRGERCUSMA,CDOPERCUSMA,IDTPMANUAL,
       VRCUSUNITMA,VRCUSUNITMA1,
       VRCUSUNIT2MA,VRCUSUNI2MA1)
      VALUES
      (P_CDSEQCUSSE,P_CDFILIAL,P_CDCIA,P_CDMANCIA,
       P_CDSERVICO,/*P_CDCLASSE,P_CDCICLO,*/
       P_DTCUSTO,SYSDATE,P_CDOPERADOR,P_IDTIPMAN,
       V_CUSULCLIQSERT,V_CUSULCBRUSERT,
       V_CUSMEDLIQSERT,V_CUSMEDBRUSERT);
   END IF;

   VRCUSULCLIQSER := V_CUSULCLIQSERT;
   VRCUSULCBRUSER := V_CUSULCBRUSERT;
   VRCUSMEDLIQSER := V_CUSMEDLIQSERT;
   VRCUSMEDBRUSER := V_CUSMEDBRUSERT;
END;
/
